﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Editor.Collections
{
    public interface ISimpleList<T>
    {
        T this[int index] { get; }

        int ItemCount { get; }
        void Add( T item );
        void Clear();
        int IndexOf( T item );
        int IndexOf( T item, int startIndex );
        void Insert( int index, T item );
        void InsertRange( int index, T[] items );
        bool Remove( T item );
        void RemoveAt( int index );
        void RemoveRange( int index, int length );
    }
}
