﻿using System;
using System.Collections.Generic;
using Editor.Commands;
using Editor.Text;
using Editor.View;

namespace Editor.Document
{
    public interface IDocument : ICommandManager, IChangeHandler
    {
        IDocumentRow this[int index] { get; }
        string Name { get; set; }
        int RowCount { get; }
        ISelection Selection { get; }

        event EventHandler RowAdded;
        event EventHandler RowChanged;
        event EventHandler RowRemoved;

        int IndexOf( IDocumentRow row );
    }
}
