﻿using System;
using System.Collections.Generic;
using System.Text;
using Editor.Numbering;
using Editor.View;

namespace Editor.Document.UseCase
{
    public sealed class AlternativeFlow : Flow
    {
        private StepRow alternativeStep;

        public override string CurrentNumber
        {
            get
            {
                StringBuilder buffer = new StringBuilder();

                buffer.Append( numbering.ToString() );
                buffer.Append(" : ");
                buffer.Append( (alternativeStep.Parent as INumbered).CurrentNumber );
                buffer.Append('-');
                buffer.Append( (alternativeStep as INumbered).CurrentNumber );

                return buffer.ToString();
            }
        }

        public override string LongestNumber
        {
            get
            {
                StringBuilder buffer = new StringBuilder();

                buffer.Append( numbering.LongestNumber );
                buffer.Append(" : ");
                buffer.Append( (alternativeStep.Parent as INumbered).LongestNumber  );
                buffer.Append('-');
                buffer.Append( (alternativeStep as INumbered).LongestNumber);

                return buffer.ToString();
            }
        }

        public AlternativeFlow( INumbering numbering, string name, StepRow alternativeStep ) : base( numbering, name )
        {
            this.alternativeStep = alternativeStep;

            alternativeStep.ObjectChanged += new EventHandler(OnAlternativeStepChanged);
        }

        public void OnAlternativeStepChanged(object sender, EventArgs e)
        {
            NumberingChangedEvent( this, EventArgs.Empty );
        }
    }
}
