﻿using System;
using System.Collections.Generic;
using System.Text;
using Editor.Numbering;
using Editor.View;
using System.Drawing;
using Editor.Text;

namespace Editor.Document.UseCase
{
    public sealed class DocumentSection : TemplateRow, ITypeable<ESectionType>
    {
        private ESectionType sectionType;

        public override bool Editable
        {
            get { return false; }
        }

        public override bool Formattable
        {
            get { return false; }
        }

        public bool LevelChanging
        {
            get { return false; }
        }

        public override bool Removable
        {
            get { return false; }
        }

        public ESectionType Type
        {
            get { return sectionType; }
        }

        public DocumentSection( string name, ESectionType sectionType ) : base()
        {
            this.sectionType = sectionType;

            text.BeginChange();
            text.InsertString( 0, name );
            text.ChangeStyle( 0, text.VirtualLength, (short)EDefaultStyles.Section );
        }

        public override TemplateRow CreateNewRow()
        {
            return null;
        }

        public override string ToString()
        {
            return text.ToString();
        }
    }
}
