﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Editor.Document;

namespace Editor.Project
{
    public sealed class UseCase : TreeNode, IProjectItem
    {
        private EventArgs changeArgs;
        private UseCaseDocument document;
        private UseCaseModel model;
        private bool objectChanging;
        private bool saved;

        public bool Changing
        {
            get { return objectChanging; }
        }

        public UseCaseDocument Document
        {
            get { return document; }
        }

        public IProjectItem this[int index]
        {
            get { throw new NotImplementedException(); }
        }

        public bool Composite
        {
            get { return false; }
        }

        public int ItemCount
        {
            get { throw new NotImplementedException(); }
        }

        public string ItemName
        {
            get { return Text; }
            set 
            { 
                Text = value;

                ObjectChangedEvent( this, EventArgs.Empty );
            }
        }

        public IProjectItem ParentItem
        {
            get { return model as IProjectItem; }
        }

        public bool Saved
        {
            get { return saved; }
            set
            {
                saved &= value;
            }
        }

        public event EventHandler ObjectChanged;
        public event EventHandler ObjectChanging;

        public UseCase( string name, UseCaseModel model )
        {
            changeArgs = null;
            document = new UseCaseDocument( name, model );
            ImageIndex = 1;
            objectChanging = false;
            this.model = model;
            saved = false;
            SelectedImageIndex = 1;
            Text = name;

            document.ObjectChanged += OnDocumentChanged;
        }

        public void Add( IProjectItem item )
        {
            throw new NotImplementedException();
        }

        public void BeginChange()
        {
            if( !objectChanging )
            {
                objectChanging = true;
                changeArgs = null;

                if( ObjectChanging != null ) ObjectChanging( this, EventArgs.Empty );
            }
        }

        public void Clear()
        {
            throw new NotImplementedException();
        }

        public IProjectItem CreateSubItem( Arguments argumets )
        {
            throw new NotImplementedException();
        }

        public void EndChange( bool discardEvent )
        {
            if( objectChanging )
            {
                objectChanging = false;

                if( !discardEvent && changeArgs != null ) ObjectChangedEvent( this, changeArgs ); 
            }
        }

        public Delegate[] GetReferences()
        {
            return ObjectChanged.GetInvocationList();
        }

        public int IndexOf( IProjectItem item )
        {
            throw new NotImplementedException();
        }

        public int IndexOf( IProjectItem item, int startIndex )
        {
            throw new NotImplementedException();
        }

        public void Insert( int index, IProjectItem item )
        {
            throw new NotImplementedException();
        }

        public void InsertRange( int index, IProjectItem[] items )
        {
            throw new NotImplementedException();
        }

        public bool Load( Arguments arguments )
        {
            throw new NotImplementedException();
        }

        public bool Remove( IProjectItem item )
        {
            throw new NotImplementedException();
        }

        public void RemoveAt( int index)
        {
            throw new NotImplementedException();
        }

        public void RemoveRange( int index, int length )
        {
            throw new NotImplementedException();
        }

        public bool Save( Arguments arguments )
        {
            throw new NotImplementedException();
        }

        private void ObjectChangedEvent( object sender, EventArgs eventArgs )
        {
            if( objectChanging ) 
            {
                changeArgs = eventArgs;
                return;
            }

            if( ObjectChanged != null ) ObjectChanged( sender, eventArgs );
        }

        private void OnDocumentChanged( object sender, EventArgs eventArgs )
        {
            ObjectChangedEvent( sender, eventArgs );
        }
    }
}
