﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace Editor.View
{
    public interface IViewLine
    {
        ISegment this[int index] { get; set; }
        int Height { get; }
        int ItemCount { get; }
        IViewRow ViewRow { get; }

        void Add( ISegment item );
        void Clear();
        void Draw( int offset, bool selected );
        void Draw( int offset, int selectionStart );
        void Draw( int offset, int selectionStart, int selectionEnd );
        void Insert( int index, ISegment item );
    }
}
