﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Editor.Document;
using Editor.View;
using Editor;

namespace UseCaseTool.Controls
{
    public sealed class DocumentTabPage : TabPage
    {
        private UseCaseEditor editor;

        public UseCaseDocument Document
        {
            get { return editor.View.Document as UseCaseDocument; }
        }

        public UseCaseEditor Editor
        {
            get { return editor; }
        }

        public UseCaseView View
        {
            get { return editor.View; }
        }

        public DocumentTabPage( UseCaseDocument document )
        {
            editor = new UseCaseEditor( document );
            editor.Dock = DockStyle.Fill;

            Text = document.Name;

            Controls.Add( editor );
        }
    }
}
